 
%addpath(genpath('../../../cvx'));
cvx_setup
clc
clear
Kmax=8;
cconsall=[0.25 0.5 0.75];
rrate=-1/3;

DDGP=1;

if DDGP==5
include_time_effect=1;
else
include_time_effect=0;
end


sstandardized=0;
ppostlasso=1;

    
    
        RR=1000;
        NTcomb=[40 10; 80 10; 40 40];%[40 10; 40 20; 40 40; 80 10; 80 20; 80 40];

for ssamplesize=1:size(NTcomb,1)
for connsindex=1:max(size(cconsall))
    

     ccons=cconsall(connsindex);
    

    
    clear  J_original_post  saved_final_beta_hat informationcriterion IC_selected test_selected beta_lasso_pre_saved beta_lasso_post_saved beta_true_lasso_post_saved
    clear beta_one_group_saved beta_true_saved infeasible_beta_saved beta_random_coeff

    
    
    N=NTcomb(ssamplesize,1);
    T=NTcomb(ssamplesize,2);  

  


for r=1:RR
 

%generating data%%%%%%%%%%%%%%%%%%%
randn('state',r)
rand('state',r)


p=2;                                        %
generatingdata 
beta_true=beta;                             %


OX=X;
OY=Y;


cccvalue=norminv(1-1/T,0,1);


lambda1=ccons*std(reshape(OY,N*T,1))^2*T^(rrate);%


%infeasible estimator
infeasible_beta=[];


if DDGP==1||DDGP==2||DDGP==4||DDGP==5
for ggg=1:3

    if ggg==1
group_X_true=X(1:N*0.3,:,:);
group_Y_true=Y(1:N*0.3,:);
    end
    if ggg==2
group_X_true=X(N*0.3+1:N*0.6,:,:);
group_Y_true=Y(N*0.3+1:N*0.6,:);
    end
    if ggg==3
group_X_true=X(N*0.6+1:end,:,:);
group_Y_true=Y(N*0.6+1:end,:);
    end
    
    if include_time_effect==1  
    [final_beta_hat  NTresiduals]=within_est_time_effect(group_X_true,group_Y_true);   
    else
    [final_beta_hat  NTresiduals]=within_est(group_X_true,group_Y_true);   
    end

    infeasible_beta=[infeasible_beta; final_beta_hat];
    
end
end




 %random coefficient models
for iiiii=1:N
    temp=[reshape(X(iiiii,:,:),T,p) ones(T,1)]\Y(iiiii,:)';
    beta_random_coeff(iiiii,:,r)=temp(1:p)';
end



clear beta_lasso_post beta_true_lasso_post beta_lasso_pre

for K=1:Kmax
   

X=OX;
Y=OY;
    
if K==1
    
if include_time_effect==1  
[final_beta_hat  NTresiduals]=within_est_time_effect(X,Y);   
else
[final_beta_hat  NTresiduals]=within_est(X,Y);   
end

beta_one_group=final_beta_hat;

beta_lasso_post(:,:,1)=final_beta_hat;
beta_true_lasso_post(:,:,1)=final_beta_hat;

end


if K>1
    
    
if include_time_effect==1    
[beta_hat NTresiduals_Lasso]=c_lasso_est_time_effect(OX,OY,K,lambda1);
[final_beta_hat NTresiduals]=post_lasso_time_fixed_effects(OX,OY,beta_hat);
else 
[beta_hat NTresiduals_Lasso]=c_lasso_est(OX,OY,K,lambda1);
[final_beta_hat NTresiduals]=post_lasso(OX,OY,beta_hat);
end




end 

saved_final_beta_hat(:,:,K,r)=final_beta_hat;
J_original_post(K,r)=test_stat(NTresiduals,OX);



end %end K


temp_test_selected=find(J_original_post(:,r)<=cccvalue,1);

if isempty(temp_test_selected)==1
test_selected(:,r)=N;
beta_lasso_post_saved(:,:,r)=beta_random_coeff(:,:,r);
       
else
test_selected(:,r)=temp_test_selected;
beta_lasso_post_saved(:,:,r)=saved_final_beta_hat(:,:,temp_test_selected,r);
end

beta_one_group_saved(:,:,r)=beta_one_group;
beta_true_saved(:,:,r)=beta_true;


if DDGP==3
infeasible_beta_saved(:,:,r)=beta_random_coeff(:,:,r);
else
infeasible_beta_saved(:,:,r)=infeasible_beta;
end

end %end r


t1=1/N*mean(sum(norms((beta_one_group_saved-beta_true_saved)).^2));
t2=1/N*mean(sum(norms((beta_random_coeff-beta_true_saved)).^2));
t3(connsindex,:)=1/N*mean(sum(norms((beta_lasso_post_saved-beta_true_saved)).^2));
t4=1/N*mean(sum(norms((infeasible_beta_saved-beta_true_saved)).^2));

end 

disp('XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX')
disp(['DGP=',num2str(DDGP),' N=',num2str(N),' T=',num2str(T),' the constant=',num2str(ccons)])
disp('XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX')
disp([t1 t2 t3(1) t3(2) t3(3) t4]);


end 


toc


