clc
clear
%addpath(genpath('../../../cvx'));
cvx_setup
warning off

%generating data
randn('state',0)
rand('state',0)

N=50;
T=50;
p=2;

beta=zeros(N,p);
beta(1:N*0.3,:)=repmat([0.5 -0.5],N*0.3,1);
beta(N*0.3+1:N*0.6,:)=repmat([-0.5 0.5],N*0.3,1);


%beta(:,1)=0.5+randn(N,1);
%beta(:,2)=-0.5+rand(N,1);


%beta=ones(N,2);


mu=randn(N,1);

for ppp=1:p
X(:,:,ppp)=randn(N,T)+repmat(mu,1,T);
end
u=randn(N,T);
Y=repmat(mu,1,T)+u;
for ppp=1:p
    Y=Y+repmat(beta(:,ppp),1,T).*X(:,:,ppp);
end

%testing 

OX=X;
OY=Y;
cccvalue=norminv(1-1/T,0,1);
ccons=0.25;
rrate=-1/3;
Kmax=8;
include_time_effect=0;
lambda1=ccons*std(reshape(OY,N*T,1))^2*T^(rrate);%



for K=1:Kmax
   

X=OX;
Y=OY;
    
if K==1
    
if include_time_effect==1  
[final_beta_hat  NTresiduals]=within_est_time_effect(OX,OY);   
else
[final_beta_hat  NTresiduals]=within_est(OX,OY);   
end

end



if K>1
    
    
if include_time_effect==1    
[beta_hat NTresiduals_Lasso]=c_lasso_est_time_effect(OX,OY,K,lambda1);
[final_beta_hat NTresiduals]=post_lasso_time_fixed_effects(OX,OY,beta_hat);
else 
[beta_hat NTresiduals_Lasso]=c_lasso_est(OX,OY,K,lambda1);
[final_beta_hat NTresiduals]=post_lasso(OX,OY,beta_hat);
end




end 

r=1;
sigma_hat_2=mean(mean(NTresiduals.^2));                    
rho=2/3*(N*T)^(-1/2);

informationcriterion(K,r)=log(sigma_hat_2)+rho*p*K;

saved_final_beta_hat(:,:,K,r)=final_beta_hat;

J_original_post(K,r)=test_stat(NTresiduals,OX);



end %end K


temp=find(J_original_post<=cccvalue,1);
if isempty(temp)~=1
estgroupnumber=temp(1);
reported_estimate=saved_final_beta_hat(:,:,temp(1),r);
else
estgroupnumber=N;
for iiiii=1:N
    temp=[reshape(OX(iiiii,:,:),T,p) ones(T,1)]\OY(iiiii,:)';
    beta_random_coeff(iiiii,:)=temp(1:p)';
end
saved_groupmember{estgroupnumber}=[1:N]';
reported_estimate=beta_random_coeff;
end




disp('XXXXXXXXXXXXXXXXXXXXXXX')
disp(['number of groups = ', num2str(estgroupnumber)])
disp('XXXXXXXXXXXXXXXXXXXXXXX')

disp('Post C-Lasso estimates')
disp(reported_estimate)


